{Use Pascal Pretty Printer, (C)2001 by Lavrov Dmyry}
{$h+}
{******************************Helper routines*********************}

const leftBR='\b(';RightBR=')';
function upcase(s:string):string;
var n:longint;
begin
  SetLength(result,length(s));
  for n:=1 to length(s) do result[n]:=system.UpCase(s[n]);
end;
function find(const s:string;const a:array of string):longint;
var n:longint;maxlen:longint;
begin
  MaxLen:=0;
    result:=-1;
  for n:=0 to high(a) do if UpCase(a[n])=upCase(copy(s,1,length(a[n]))) then
  begin
  if length(a[n])>maxlen then begin
    maxlen:=length(a[n]);
    result:=n;
   end;
  end;

end;



type TParser=object
  s:string;
  LastToken:string;
  LastTokenN:longint;
  token:String;
  tokenN:Longint;
  pos:LongInt;
  Function NextToken:string;
end;
const
T_end=0;
const Spaces{:set of char}=[#9,' '];
const AllChars{:Set Of Char}=[#1..#255];{0 is a end of expression}
const Symbols{:set of char}=['+','-','*','/','(','|',')',',','.','^','\','>','=','<']{AllChars-dig-abc};
const Operators=['+','-','*','/','\','^','.'];
const SpecSymbols:array[0..6] of string=('**','>=','<=','=>','=<','<>',':=');
const ABC123=AllChars-Spaces-Symbols;
const Digits=['0'..'9'];
t_num=1;
t_abc=2;
t_symbol=3;

Const NonSkipable:set of char=['(',')',',',';','|'];
function Tparser.NextToken:string;
var tmpI:longint;
label _exit;
begin
  LastToken:=token;
  LastTokenN:=tokenN;

  Token:='';
  if pos>length(s)then begin
      token:=';';
      TokenN:=t_end;
      goto _exit;
    end;

  if s[pos] in spaces then begin
    inc(pos);
    while (s[pos]in Spaces)and(pos<=length(s)) do inc(pos);
    if pos>length(s)then begin
      token:=';';
      TokenN:=t_end;
      goto _exit;
    end;
    if not(s[pos] in Operators) then begin
      token:=' ';
      tokenN:=t_symbol;
      goto _exit;
    end;
  end;
  if s[pos] in Symbols then begin
  tmpI:=find(copy(s,pos,10000),SpecSymbols);
  if tmpI<>-1 then begin token:=SpecSymbols[tmpI];pos:=pos+length(SpecSymbols[tmpI]); end else
  begin
  token:=s[pos];
  inc(pos);
  end;
  TokenN:=t_symbol;
  end else if s[pos] in digits then begin
   while (not(s[pos]in symbols-['.']+spaces))and(pos<=length(s)) do begin Token:=Token+s[pos];inc(pos);end;
    TokenN:=T_num;
  end else

  begin
    while (not(s[pos]in symbols+spaces))and(pos<=length(s)) do begin Token:=Token+s[pos];inc(pos);end;
    TokenN:=T_abc;
  end;
  _exit:
  NextToken:=token;
end;
type Tfunct=function :string;
type Tfunct1=function(a:string):string;
type Tfunct2=function(a,b:string):string;
type Tfunct3=function(a,b,c:string):string;
type Tint=record
  Name:string;
  Params:byte;
  case byte of
  0:(f0:Tfunct);
  1:(f1:Tfunct1);
  2:(f2:Tfunct2);
  3:(f3:Tfunct3);
  4:(p:pointer)
end;
function RmBr(const s:string):string;
var n,cl:longint;
begin
  if (s<>'')and (s[length(s)]=')')and((s[1]='(')or(copy(s,1,length(LeftBR))=LeftBR)) then begin
    cl:=0;
    for n:=1 to length(s)-1 do begin
      if s[n]='(' then inc(cl) else
      if s[n]=')' then begin
        dec(cl);if cl=0 then begin result:=s; exit;end;
      end;

    end;{for}
if (copy(s,1,length(LeftBR))=LeftBR) then result:=copy(s,length(LeftBR)+1,length(s)-length(LeftBR)-1) else result:=copy(s,2,length(s)-2);
    exit;
  end else result:=s;
end;
function _pi:string;
begin
  _pi:='pi';
end;
function _e:string;
begin
  _e:='e';
end;
function exp10(a:string):string;
begin
  exp10:='10\s\up6('+RmBr(a)+')';
end;
function log10(a:string):string;
begin
  log10:='log\s\do5(10)'+LeftBr+a+RightBr;
end;
function _sqr(a:string):string;
begin
  _sqr:=a+'\s\up6(2)';
end;
function _sqrt(a:string):string;
begin
  _sqrt:='\r(;'+RmBr(a)+')';
end;
function _root(n,b:string):string;
begin
  _root:='\r('+n+';'+RmBr(b)+')';
end;

function _int(d,u,a:string):string;
begin
  _int:='\i('+d+';'+u+'; '+a+')';
end;
function _sigma(d,u,a:string):string;
begin
  _sigma:='\i\su('+d+';'+u+'; '+a+')';
end;
function _pr(d,u,a:string):string;
begin
  _pr:='\i\pr('+d+';'+u+'; '+a+')';
end;

function _exp(a:string):string;
begin
  _exp:='e\s\up6('+RmBr(a)+')';
end;
{function _ln(a:string):string;
begin
_ln:='ln('+a+')';
end; }
const
MaxInternalF=11;
InternalFs:array[1..MaxInternalF] of Tint=(
{(name:'SIN$1';params:1;p:@_sin),
(name:'COS$1';params:1;p:@_cos),
(name:'TAN$1';params:1;p:@_tan),
(name:'ASIN$1';params:1;p:@_arcsin),
(name:'ACOS$1';params:1;p:@_arccos),
(name:'ATAN$1';params:1;p:@_arctan),}{6}
(name:'EXP$1';params:1;p:@_exp),{(name:'LN$1';params:1;p:@_ln),}
(name:'LOG10$1';params:1;p:@log10),(name:'EXP10$1';params:1;p:@exp10),
(name:'SQR$1';params:1;p:@_SQR),(name:'SQRT$1';params:1;p:@_SQRT),
(name:'ROOT$2';params:2;p:@_ROOT),
(name:'INT$3';params:3;p:@_INT),
(name:'SIGMA$3';params:3;p:@_sigma),
(name:'SUMM$3';params:3;p:@_sigma),
(name:'PR$3';params:3;p:@_PR),
(name:'PI$0';params:0;p:@_pi){,(name:'E$0';params:0;p:@_E)}
); {10}

function Calc(const st:string):string;
var i:Tparser;
procedure Error;
begin
  {Writeln('Error! Pos=',i.pos);
  Writeln(Copy(i.s,1,i.pos),'?',Copy(i.s,i.pos+1,10000));
  Writeln('Token ',i.Token);
  Writeln('LastToken ',i.LastToken);
  Runerror(255); }
end;
function Calc_High:string;forward;
function Calc_Power:string;forward;
function Calc_Mul_Div:string;forward;
function Calc_Add_Sub:string;
var v:string;
begin
  with i do begin
    v:=Calc_Mul_Div;
    while (TokenN<>T_End) do begin
      if token[1]='+' then begin
        NextToken;
        v:=v+'+'+Calc_Mul_div;
        end else if token[1]='-' then begin
        NextToken;
        v:=v+'-'+Calc_Mul_Div;
        end else if not(token[1] in NonSkipable) then begin
        v:=v+token;
        NextToken;
        if TokenN=t_end then break;
        v:=v+Calc_Mul_Div;
      end
      else break;{not +,not -,not mul_div..}
      {   NextToken;}
    end{while};
  end{with};
  Calc_Add_Sub:=v;
end;
function Calc_Mul_Div:string;
var v:string;
begin
  with i do begin
    v:=Calc_Power;
    while (TokenN<>T_End) do begin
      if token='*' then begin
        NextToken;
        v:=v+'*'+Calc_Power;
      end
      else if token=' ' then begin
        NextToken;
        v:=v+' '+Calc_Power;
      end
      else if token='/' then begin
        NextToken;
        v:='\f('+RmBr(v)+';'+RmBr(Calc_Power)+')';
      end
      else if token='\' then begin
        NextToken;
        v:=v+'/'+Calc_Power;
      end else break;

    end{while};
  end {with};
  Calc_Mul_Div:=v;
end;
function Calc_Power:string;
var v:string;
begin
  with i do begin
    v:=Calc_High;
    while (TokenN<>T_End) do begin
      if (token='**')or(token='^') then begin
        NextToken;
        v:=v+'\s\up6('+RmBr(Calc_High)+')';
      end else
      if (token='.') then begin
        NextToken;
        v:=v+'\s\do6('+RmBr(Calc_High)+')';
      end else break;
    end{while};
  end {with};
  Calc_Power:=v;
end;
function Calc_High:string;
var v:string;
ErrPos:longint;
Nam,nam2:string;
Params:string;
ParamsA:array[1..256] of string;
Nparam,InternFunc:longint;j:longint;
label _ok;

begin
  v:='';
  with i do begin
    if TokenN=t_num then begin
      {val(Token,v,ErrPos);
      if ErrPos<>0 then begin
      pos:=pos+ErrPos;
      Error;
      end;}
      v:=token;
      NextToken;
      {if Token='.' then begin v:=v+token;nexttoken;v:=v+token;end;}
    end {else if Token='.' then begin
      v:=v+'\s\do4('+RmBr(Calc_High)+')';
    end} else
    if Token='(' then begin
      NextToken;
      v:=v+LeftBR+Calc_Add_Sub;
      if token<>')' then error;
      v:=v+RightBR;
      NextToken;
      end else
      if Token='|' then begin
      NextToken;
      v:=v+'\b\bc\|('+Calc_Add_Sub;
      if token<>'|' then error;
      v:=v+')';
      NextToken;
      end else
      if tokenN=t_abc then begin
      nam:=Token;
      NextToken;
      Nparam:=0;
      if Token='(' then begin
        repeat
          NextToken;
          inc(Nparam);
          if nparam>256 then error;
          ParamsA[nparam]:=Calc_Add_Sub;
        until Token<>',';
        if Token<>')' then error;
        NextToken;
      end;
      str(Nparam,params);
      nam2:=UpCase(nam+'$'+params);
      {internals}
      for InternFunc:=1 to MaxInternalF do with InternalFs[InternFunc] do begin
        if name=nam2 then begin
          {}
          case Nparam{InternalFs.params} of
            0:v:=f0();
            1:v:=f1(ParamsA[1]);
            2:v:=f2(ParamsA[1],ParamsA[2]);
            3:v:=f3(ParamsA[1],ParamsA[2],paramsa[3]);
          end;
          {}
          Goto _ok;
        end;
      end;
      v:=v+nam;
      if nparam<>0 then begin
        v:=v+LeftBR;
        for j:=1 to nparam do begin
          v:=v+ParamsA[j];
          if j<>nparam then v:=v+',';
        end;
        v:=v+RightBR;
      end;
      _ok:
    end;
  end {with};
  Calc_High:=v;
end;


begin
  i.s:=st;
  i.pos:=1;
  i.Token:='';
  I.NextToken;
  if i.TokenN=t_end then exit;
  calc:=Calc_Add_Sub;
end;
{
function Scalc(s:string):string;export;stdcall;
begin
Scalc:=calc(s);
end;
exports Scalc index 1 name 'Scalc';  }
